// mfc_glView.cpp : implementation of the CMfc_glView class
//

#include "stdafx.h"

#include "mfc_gl.h"

#include "mfc_glDoc.h"
#include "mfc_glView.h"
#include "MainFrm.h"
#include "DglView.h"
#include "DlgRobSel.h"
#include "font.h"

#include <math.h>
#include <String>
using namespace std;

const double M_PI=3.1415926535898;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------------------------------
// CMfc_glView

IMPLEMENT_DYNCREATE(CMfc_glView, CView)

BEGIN_MESSAGE_MAP(CMfc_glView, CView)
	//{{AFX_MSG_MAP(CMfc_glView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_RUN_ANIMATE, OnRunAnimate)
	ON_WM_TIMER()
	ON_COMMAND(ID_RUN_RESET, OnRunReset)
	ON_COMMAND(ID_AFFICHAGE_GLVIEW, OnAffichageGlview)
	ON_UPDATE_COMMAND_UI(ID_AFFICHAGE_GLVIEW, OnUpdateAffichageGlview)
	ON_COMMAND(ID_RUN_RESETVIEW, OnRunResetview)
	ON_COMMAND(IDHELP, OnHelp)
	ON_COMMAND(ID_SelRobot, OnSelRobot)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

CMfc_glView * Mfc_glView;
//---------------------------------------------------------------------------
// CMfc_glView construction/destruction
//---------------------------------------------------------------------------
CMfc_glView::CMfc_glView()
{
	// TODO: add construction code here
	t=0.0; //time
	dt=0.1; // pas temporel
  Mfc_glView=this;
	Rob2= new TRobot2( 0, 0, 0);	// cree un robot type 2 roue avec base carr 
											// pour initialiser afin de compiler les objets  dessiner
	NRobots=5;	// 5 robots
  ListeRobots=new (TRobot2 * [NRobots]);  // cree la liste des robots
  // cree plein de robots de type 2 et les ajoute  la collection de robots
	for (int i=0; i<NRobots; i++)
    {
    ListeRobots[i]=new TRobot2( i/2.-1, 0, i);
    }
	RobSel=2;	//!On selectionne le 3eme robot
	ListeRobots[RobSel]->Selected=true;

	xv=0; zv=0; zpos=+2;	//	Position de la vue
	yrot=-90; xrot=30;
	CameraMoveStep=0.25f;
	m_animate=false;
	afficheRepere=true;
	areteTransv=false;
	faceArriere=false;
	nbSubdiv=NB_SUBDIV_INIT;
  menuAffichageGlview=false;
	MouseMovesScreen=false;
	MouseRotatesScreen=false;
}
//---------------------------------------------------------------------------
CMfc_glView::~CMfc_glView()
{
}

//---------------------------------------------------------------------------
BOOL CMfc_glView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN; 
return CView::PreCreateWindow(cs);
}

//---------------------------------------------------------------------------
int fonctionTexture(int x,int y)
{
  float dx=(128.0-(float)x)/255.0*40.0;
  float dy=(128.0-(float)y)/255.0*40.0;
  float a=cos(sqrt(dx*dx+dy*dy)+0.1);
  return (int)((a+1.0)/2.0*255);
    
}
//---------------------------------------------------------------------------
void CMfc_glView::SetupTextures()
{
  int i,j;
  int a;
  CBitmap	bmp;
	BYTE* buffer;
	BITMAP info;
	int size;

  /* calcule de l'image */
  for (i=0;i<256;i++)
    for (j=0;j<256;j++) {
      a=fonctionTexture(i,j);
      image[i][j][0]=a;
      image[i][j][1]=128;
      image[i][j][2]=128;
    }
  
  /* Paramtrage de la texture */
  glGenTextures(1, &texture1);
  glBindTexture(GL_TEXTURE_2D, texture1);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,256,0, GL_RGB,GL_UNSIGNED_BYTE,image);

	if (bmp.LoadBitmap(IDB_BITMAPuhp1))
		{
//    AfxMessageBox( "hi",MB_ICONEXCLAMATION);
		bmp.GetBitmap(&info);
		size=info.bmWidth*info.bmHeight*4;
		buffer=new BYTE[size];
		bmp.GetBitmapBits(size,buffer);
		for(i=0;i<size;i+=4)
				{
				if(buffer[i]==255 && buffer[i+1]==255 && buffer[i+2]==255)	buffer[i+3]=0;
								else		buffer[i+3]=255;
				}

		glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
		glGenTextures(1, &textureUHP);
		glBindTexture(GL_TEXTURE_2D, textureUHP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 4, info.bmWidth, info.bmHeight,GL_BGRA_EXT, GL_UNSIGNED_BYTE, buffer);
		delete [] buffer;
		}

//  glEnable(GL_TEXTURE_2D);
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
}
//---------------------------------------------------------------------------
GLvoid CMfc_glView:: CreateObjects()
{
  int i,j;
  float u, v;
  float deb=10.0;
  float pas=2.0*deb/nbSubdiv;
  float P1[3],P2[3],P3[3],P4[3];
    GLUquadricObj *quadObj;

	SetupTextures();

  glNewList(Repere, GL_COMPILE);
  glLineWidth(2.0);
    glBegin(GL_LINES);
      glColor3f(1.0,0.0,0.0);
      glVertex3f(0.0,0.0,0.0);
      glVertex3f((GLfloat)0.1,(GLfloat)0.0,(GLfloat)0.0);
      glColor3f(0.0,1.0,0.0);
      glVertex3f(0.0,0.0,0.0);
      glVertex3f((GLfloat)0.0,(GLfloat)0.2,(GLfloat)0.0);
      glColor3f(0.0,0.0,1.0);
      glVertex3f(0.0,0.0,0.0);
      glVertex3f((GLfloat)0.0,(GLfloat)0.0,(GLfloat)0.3);
    glEnd();
  glLineWidth(1.0);
  glEndList();
  
  
  /* Liste pour l'objet terrain */
  if (glIsList(Terrain))	glDeleteLists(Terrain,1);
//  Terrain=glGenLists(1);
  glNewList(Terrain,GL_COMPILE);
        glPushMatrix ();
        glRotatef (-(GLfloat)90.0, (GLfloat)1.0, (GLfloat)0.0, (GLfloat)0.0);
				glColor3f(0.0,0.0,0.0);
				glLineWidth(1.0);
				for (i=0;i<nbSubdiv;i++)
					for (j=0;j<nbSubdiv;j++)
						{
						P1[0]=-deb+i*pas; P1[1]=-deb+j*pas ; P1[2]=0;
						P2[0]=-deb+(i+1)*pas; P2[1]=-deb+j*pas ; P2[2]=0;
						P3[0]=-deb+(i+1)*pas; P3[1]=-deb+(j+1)*pas ; P3[2]=0;
						P4[0]=-deb+i*pas; P4[1]=-deb+(j+1)*pas ; P4[2]=0;
						
						glBegin(GL_TRIANGLES);
						/* triangle 1 */
						glEdgeFlag(TRUE);
						glVertex3fv(P1);
						glVertex3fv(P2);
						if (!areteTransv)	glEdgeFlag(FALSE);
						glVertex3fv(P3);

						/*triangle 2 */
						glVertex3fv(P1);
						if (!areteTransv)	glEdgeFlag(TRUE);
						glVertex3fv(P3);
						glVertex3fv(P4);
						glEnd();
						}
        glPopMatrix ();
  glEndList();

		glNewList(RoueTorique, GL_COMPILE);
			glPushMatrix ();
			glRotatef (90, 0, 1, 0);
			glBegin(GL_LINE_STRIP);
  		for (u=0;u<=2*M_PI;u+=M_PI/12)
 			  for (v=0;v<=2*M_PI;v+=M_PI/12)
					glVertex3f( (Rob2->RAvD->R - Rob2->RAvD->r + Rob2->RAvD->r*cos(u))*cos(v),
								(Rob2->RAvD->R - Rob2->RAvD->r + Rob2->RAvD->r*cos(u))*sin(v),
								Rob2->RAvD->r*sin(u));
			glEnd();
      glPopMatrix ();
    glEndList();

		// roue sous forme de dosqie plat
    glNewList(Roue, GL_COMPILE);
			glPushMatrix ();
			glRotatef (90, 0, 1, 0);
      quadObj = gluNewQuadric ();
  		#ifdef Rfull
			gluQuadricDrawStyle (quadObj, GLU_FILL);
			#else
			gluQuadricDrawStyle (quadObj, GLU_LINE);
			#endif
      gluQuadricNormals (quadObj, GLU_SMOOTH);
      gluDisk (quadObj, Rob2->RAvG->R-2*Rob2->RAvG->r, Rob2->RAvG->R,16, 4);
      glPopMatrix ();
    glEndList();

    glNewList(TigeD, GL_COMPILE);
      glPushMatrix ();
			glRotatef (90, 0, 1, 0);
        quadObj = gluNewQuadric ();
				#ifdef full
				gluQuadricDrawStyle (quadObj, GLU_FILL);
				#else
				gluQuadricDrawStyle (quadObj, GLU_LINE);
				#endif
        gluQuadricNormals (quadObj, GLU_SMOOTH);
        gluCylinder(quadObj, Rob2->e, Rob2->e, Rob2->Lx, 8, 16);
        glPopMatrix ();
    glEndList();

    glNewList(Robot2Chassis, GL_COMPILE);
				glBindTexture(GL_TEXTURE_2D, textureUHP);
				glBegin(GL_POLYGON); 
				glNormal3f(0.0,0.0,1.0);	// top
				glTexCoord2f(0.0,0.0);   glVertex3f(-Rob2->Lxc/2, -Rob2->Lyc/2, Rob2->Lzc/2);
				glTexCoord2f(1.0,0.0);   glVertex3f(-Rob2->Lxc/2,  Rob2->Lyc/2, Rob2->Lzc/2);
				glTexCoord2f(1.0,1.0);   glVertex3f( Rob2->Lxc/2,  Rob2->Lyc/2, Rob2->Lzc/2);
				glTexCoord2f(0.0,1.0);   glVertex3f( Rob2->Lxc/2, -Rob2->Lyc/2, Rob2->Lzc/2);
				glEnd();
					glBindTexture(GL_TEXTURE_2D, texture1);
				glBegin(GL_POLYGON); 
				glNormal3f(1.0,0.0,0.0);	// cot droit
				glTexCoord2f(0.0,1.0);   glVertex3f( Rob2->Lxc/2, -Rob2->Lyc/2, -Rob2->Lzc/2);
				glTexCoord2f(0.0,0.0);   glVertex3f( Rob2->Lxc/2, -Rob2->Lyc/2,  Rob2->Lzc/2);
				glTexCoord2f(1.0,0.0);   glVertex3f( Rob2->Lxc/2,  Rob2->Lyc/2,  Rob2->Lzc/2);
				glTexCoord2f(1.0,1.0);   glVertex3f( Rob2->Lxc/2,  Rob2->Lyc/2, -Rob2->Lzc/2);
				glEnd();

				glBegin(GL_POLYGON);
				glNormal3f(0.0,0.0,-1.0);// cot gauche
				glTexCoord2f(0.0,1.0);   glVertex3f(-Rob2->Lxc/2, -Rob2->Lyc/2,  Rob2->Lzc/2);
				glTexCoord2f(0.0,0.0);   glVertex3f(-Rob2->Lxc/2,  Rob2->Lyc/2,  Rob2->Lzc/2);
				glTexCoord2f(1.0,0.0);   glVertex3f(-Rob2->Lxc/2,  Rob2->Lyc/2, -Rob2->Lzc/2);
				glTexCoord2f(1.0,1.0);   glVertex3f(-Rob2->Lxc/2, -Rob2->Lyc/2, -Rob2->Lzc/2);
				glEnd();

				glBegin(GL_POLYGON);
				glNormal3f(-1.0,0.0,0.0);// cot avant
				glTexCoord2f(0.0,1.0);   glVertex3f(-Rob2->Lxc/2,  Rob2->Lyc/2, -Rob2->Lzc/2);
				glTexCoord2f(0.0,0.0);   glVertex3f(-Rob2->Lxc/2,  Rob2->Lyc/2,  Rob2->Lzc/2);
				glTexCoord2f(1.0,0.0);   glVertex3f( Rob2->Lxc/2,  Rob2->Lyc/2,  Rob2->Lzc/2);
				glTexCoord2f(1.0,1.0);   glVertex3f( Rob2->Lxc/2,  Rob2->Lyc/2, -Rob2->Lzc/2);
				glEnd();

				glBegin(GL_POLYGON);
				glNormal3f(0.0,1.0,0.0);// cot arriere
				glTexCoord2f(0.0,1.0);   glVertex3f(-Rob2->Lxc/2, -Rob2->Lyc/2, -Rob2->Lzc/2); 
				glTexCoord2f(0.0,0.0);   glVertex3f(-Rob2->Lxc/2, -Rob2->Lyc/2,  Rob2->Lzc/2); 
				glTexCoord2f(1.0,0.0);   glVertex3f( Rob2->Lxc/2, -Rob2->Lyc/2,  Rob2->Lzc/2); 
				glTexCoord2f(1.0,1.0);   glVertex3f( Rob2->Lxc/2, -Rob2->Lyc/2, -Rob2->Lzc/2); 
				glEnd();

				glBegin(GL_POLYGON);
				glNormal3f(0.0,-1.0,0.0);// bottom
				glTexCoord2f(0.0,0.0);   glVertex3f(-Rob2->Lxc/2, -Rob2->Lyc/2, -Rob2->Lzc/2);  
				glTexCoord2f(0.0,1.0);   glVertex3f(-Rob2->Lxc/2,  Rob2->Lyc/2, -Rob2->Lzc/2);  
				glTexCoord2f(1.0,1.0);   glVertex3f( Rob2->Lxc/2,  Rob2->Lyc/2, -Rob2->Lzc/2);  
				glTexCoord2f(1.0,0.0);   glVertex3f( Rob2->Lxc/2, -Rob2->Lyc/2, -Rob2->Lzc/2);  
				glEnd();
      glEndList();

    glNewList(Robot4Chassis, GL_COMPILE);
        glPushMatrix ();
//        glTranslatef (0, 0, (GLfloat)-Rob2->Lt/2);
				glBegin(GL_POLYGON);
          glColor3f(1.0,0.0,0.0);
          glNormal3f(0.0,0.0,1.0);
					glTexCoord2f(0.0,1.0);   glVertex3f(-0.5, 0.5, 0.5);
					glTexCoord2f(0.0,0.0);   glVertex3f(-0.5,-0.5, 0.5); glTexCoord2f(1.0,0.0);
					glVertex3f( 0.5,-0.5, 0.5); glTexCoord2f(1.0,1.0);   glVertex3f( 0.5, 0.5, 0.5);
				glEnd();
        glPopMatrix ();
    glEndList();

}
//---------------------------------------------------------------------------
GLvoid CMfc_glView::initializeGL(GLsizei width, GLsizei height)
{
GLfloat aspect;
    glClearIndex( (GLfloat)BLACK_INDEX);
    glClearDepth( 1.0 );
    glEnable(GL_DEPTH_TEST);
//ajout
 	glEnable(GL_COLOR);

// ajout pmaillage plan
  glClearColor((GLfloat)0.8,(GLfloat)0.8,(GLfloat)0.8,(GLfloat)1.0);

	glMatrixMode( GL_PROJECTION );
	aspect = (GLfloat) width / height;
	gluPerspective( 45.0, aspect, 0.01, 7.0 );
	glMatrixMode(GL_MODELVIEW);
	SetupTextures();
  CreateObjects();
  makeRasterFont();
}
//---------------------------------------------------------------------------
void	CMfc_glView::DrawScene()
{
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
//  mix example
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

  glTranslatef(0, 0, -zpos);
  glRotatef(xrot,1,0,0);
		// marque au sol du point de vision
			glColor4f((GLfloat)1.0,  (GLfloat)1.0,  0.0, 1.0 ); 
			glBegin( GL_TRIANGLES ); 
				glVertex3f( 0.0f, 0.0f, -0.1f); 
				glVertex3f( 0.086f, 0.0f,  0.05f); 
				glVertex3f(-0.086f, 0.0f,  0.05f); 
			glEnd(); 
  glRotatef(yrot,0,1,0);
  glTranslatef(-xv, 0, -zv);

	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
  glCallList(Terrain);
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glPushMatrix ();
		glRotatef (-90.0, (GLfloat)1.0, (GLfloat)0.0, (GLfloat)0.0); // repere xy au sol !
		if (afficheRepere)   glCallList(Repere);
	// dessine les Robots
		for (int i=0; i<NRobots; i++)
        ListeRobots[i]->Dessine();

	glPopMatrix ();
	CalculateFrameRate();
}
//---------------------------------------------------------------------------
void CMfc_glView::CalculateFrameRate()
{
TCHAR SS[50];
static float framesPerSecond    = 0.0f;					
    	static float lastTime			= 0.0f;				
	float currentTime = GetTickCount() * 0.001f;	
			
	++framesPerSecond;

	if( currentTime - lastTime > 1.0f )
   	    {
				lastTime = currentTime;
				wsprintf(SS, L"Frame Per Second : %f", framesPerSecond);
				pMainframe->m_wndStatusBar.SetPaneText(pMainframe->m_wndStatusBar.CommandToIndex(ID_INDICATOR_Frame), SS);
				pMainframe->m_wndStatusBar.Invalidate();
				framesPerSecond = 0;
				}
}

//---------------------------------------------------------------------------
// CMfc_glView drawing

void CMfc_glView::OnDraw(CDC* pDC)
{
	CMfc_glDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

  // TODO: add draw code for native data here 
  wglMakeCurrent(pDC->m_hDC, m_hRC); 

	DrawScene();
	SwapBuffers(pDC->m_hDC); 
	wglMakeCurrent( NULL, NULL ); 
	ValidateRect(NULL); 
}

//---------------------------------------------------------------------------
// CMfc_glView printing

BOOL CMfc_glView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
//---------------------------------------------------------------------------
void CMfc_glView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}
//---------------------------------------------------------------------------
void CMfc_glView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
//---------------------------------------------------------------------------
// CMfc_glView diagnostics

#ifdef _DEBUG
void CMfc_glView::AssertValid() const
{
	CView::AssertValid();
}
//--------------------------------------------------------------------
void CMfc_glView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMfc_glDoc* CMfc_glView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMfc_glDoc)));
	return (CMfc_glDoc*)m_pDocument;
}
#endif //_DEBUG
//---------------------------------------------------------------------------
void CMfc_glView::UpdateStatusBarRobSel()
{	// Met  jour la StatusBar en fonction du robot slectionn
	TCHAR SS[50];
	switch( ListeRobots[RobSel]->Type)
		{
		case TypeRobot2		: wsprintf(SS, L"Selectionn : %d | Type Robot2", ListeRobots[RobSel]->Numero); break;
		case TypeRobot4		: wsprintf(SS, L"Selectionn : %d | Type Robot4", ListeRobots[RobSel]->Numero); break;
		case TypeRobotK		: wsprintf(SS, L"Selectionn : %d | Type RobotK", ListeRobots[RobSel]->Numero); break;
		default : wsprintf(SS, L"Selectionn : %d : : Robot??", ListeRobots[RobSel]->Numero); break;
		}
	pMainframe->m_wndStatusBar.SetPaneText(pMainframe->m_wndStatusBar.CommandToIndex(ID_INDICATOR_RobSel), SS);
	pMainframe->m_wndStatusBar.Invalidate();
}
//---------------------------------------------------------------------------
void CMfc_glView::FillCBListe()
{	// remplit la ComboListe avec le numro du Robot et son intitul
	TCHAR SS[50];
  for (int i=0; i<NRobots; i++)
    {
    switch( ListeRobots[i]->Type)
		{
		case TypeRobot2		: wsprintf(SS, L"%d : Robot2", ListeRobots[i]->Numero); break;
		case TypeRobot4		: wsprintf(SS, L"%d : Robot4", ListeRobots[i]->Numero); break;
		case TypeRobotK		: wsprintf(SS, L"%d : RobotK", ListeRobots[i]->Numero); break;
		default : wsprintf(SS, L"%d : : Robot??", ListeRobots[i]->Numero); break;
		}
		pMainframe->m_ComboListe.AddString(SS);
    }
  pMainframe->m_ComboListe.SetCurSel(RobSel);
	UpdateStatusBarRobSel();
}
//---------------------------------------------------------------------------
// CMfc_glView message handlers
int CMfc_glView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	pMainframe = static_cast<CMainFrame *>(GetParentFrame());	// rcupre un pointeur sur le CMainFrame

	DglView=new CDglView(this);
  DglView->Create( IDD_DIALOG1, this);
  DglView->initSliders();
	// TODO: Add your specialized creation code here

       PIXELFORMATDESCRIPTOR   pfd; 
       int     pixelFormat; 

		CClientDC clientDC(this);
//		m_hDC = ::GetDC(m_hWnd); 

       pfd.nSize =             sizeof(PIXELFORMATDESCRIPTOR); 
       pfd.nVersion =          1; 
       pfd.dwFlags =           PFD_DRAW_TO_WINDOW | 
                               PFD_SUPPORT_OPENGL | 
                               PFD_DOUBLEBUFFER; 
       pfd.iPixelType =        PFD_TYPE_RGBA; 
       pfd.cColorBits =        24; 
       pfd.cRedBits =          0; 
       pfd.cRedShift =         0; 
       pfd.cGreenBits =        0; 
       pfd.cGreenShift =       0; 
       pfd.cBlueBits =         0; 
       pfd.cBlueShift =        0; 
       pfd.cAlphaBits =        0; 
       pfd.cAlphaShift =       0; 
       pfd.cAccumBits =        0; 
       pfd.cAccumRedBits =     0; 
       pfd.cAccumGreenBits =   0; 
       pfd.cAccumBlueBits =    0; 
       pfd.cAccumAlphaBits =   0; 
       pfd.cDepthBits =        0; 
       pfd.cStencilBits =      0; 
       pfd.cAuxBuffers =       0; 
       pfd.iLayerType =        PFD_MAIN_PLANE; 
       pfd.bReserved =         0; 
       pfd.dwLayerMask =       0; 
       pfd.dwVisibleMask =     0; 
       pfd.dwDamageMask =      0; 

       pixelFormat = ChoosePixelFormat(clientDC.m_hDC, &pfd); 

       DescribePixelFormat(clientDC.m_hDC, pixelFormat, 
                           sizeof(PIXELFORMATDESCRIPTOR), 
                           &pfd); 

       if(SetPixelFormat(clientDC.m_hDC, pixelFormat, &pfd) == FALSE) 
                exit(1); 

       m_hRC = wglCreateContext(clientDC.m_hDC); 
       wglMakeCurrent( clientDC.m_hDC, m_hRC ); 
//        initializeGL(clientDC.cx, clientDC.cy);
        initializeGL(10, 10);
        
       wglMakeCurrent( NULL, NULL ); 
       return 0; 
}
//--------------------------------------------------------------------
void CMfc_glView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
	CClientDC clientDC(this);
	wglMakeCurrent(clientDC,m_hRC);
    glViewport( 0, 0, cx, cy); 
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	    //gluPerspective( 45.0, aspect, 0.01, 7.0 );
  gluPerspective(45,float(cx)/float(cy),0.01,100);
	glMatrixMode(GL_MODELVIEW);
    wglMakeCurrent( NULL, NULL ); 
    InvalidateRect(NULL); 
}
//--------------------------------------------------------------------
BOOL CMfc_glView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return 1;
}
//--------------------------------------------------------------------
void CMfc_glView::OnDestroy() 
{
	CView::OnDestroy();
	// TODO: Add your message handler code here
       wglMakeCurrent( NULL, NULL ); 
       wglDeleteContext( m_hRC ); 
}
//--------------------------------------------------------------------
void CMfc_glView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
  char lsChar;
  lsChar=char(nChar);
	if (lsChar==VK_UP)     zpos-=CameraMoveStep;
	if (lsChar==VK_DOWN)   zpos+=CameraMoveStep;
	if (lsChar==VK_LEFT)		{
													xv-=CameraMoveStep*cos(yrot*M_PI/180);
													zv-=CameraMoveStep*sin(yrot*M_PI/180);
													}
	if (lsChar==VK_RIGHT)   {
													xv+=CameraMoveStep*cos(yrot*M_PI/180);
													zv+=CameraMoveStep*sin(yrot*M_PI/180);
													}
	if (lsChar==VK_PRIOR)		{
													xv+=CameraMoveStep*sin(yrot*M_PI/180);
													zv-=CameraMoveStep*cos(yrot*M_PI/180);
													}
	if (lsChar==VK_NEXT)		{
													xv-=CameraMoveStep*sin(yrot*M_PI/180);
													zv+=CameraMoveStep*cos(yrot*M_PI/180);
													}
	if (lsChar=='W')	CameraMoveStep*=1.5f;
	if (lsChar=='X')	CameraMoveStep/=1.5f;

	if (lsChar=='Z')	{
                    xrot+= 2.0f;
                    if (xrot>180)   xrot-= 360.0f;
                    }
	if (lsChar=='S')	{
                    xrot-= 2.0f;
                    if (xrot<-180.0)   xrot+= 360.0f;
                    }
	if (lsChar=='Q')	{
                    yrot+= 2.0f;
                    if (yrot>180)   yrot-= 360.0f;
                    }
	if (lsChar=='D')	{
                    yrot-= 2.0f;
                    if (yrot<-180)   yrot+= 360.0f;
                   }
  if (lsChar=='A')			OnRunAnimate();
	if (lsChar=='T')			areteTransv=!areteTransv;
  if (lsChar=='R')			OnRunReset();

	MiseAjourDlgView();
  InvalidateRect(NULL); 
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
//--------------------------------------------------------------------
void CMfc_glView::OnRunAnimate() 
{
	// TODO: Add your command handler code here
	if(m_animate)
		{
		KillTimer(1);
		m_animate=false;
		}
	else
		{
		SetTimer(1,dt*1000,NULL);	
		m_animate=true;
		}	
}
//--------------------------------------------------------------------
void CMfc_glView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
  t+=dt;
	// Appelle IntegreEquation de tous les robots de la liste,  chaque pas de calcul dt
	for (int i=0; i<NRobots; i++)
        ListeRobots[i]->IntegreEquations( dt);
	InvalidateRect(NULL);			// Demande de redessiner le contenu de la fentre
	CView::OnTimer(nIDEvent);
}
//--------------------------------------------------------------------
void CMfc_glView::OnRunReset() 
{
	// TODO: Add your command handler code here
	// remise  zero du temp et demande aux robots de se "reseter"
	t=0.0; //time
	for (int i=0; i<NRobots; i++)
        ListeRobots[i]->Reset();
}
//--------------------------------------------------------------------
void CMfc_glView::MiseAjourDlgView() 
{
TCHAR buffer[50];
CEdit * Ed;
CSliderCtrl* Sl;
      Ed=(CEdit*)DglView->GetDlgItem(IDC_EDITxv);
      Ed->SetSel(0,-1);
	  wsprintf(buffer, L"%.6g", xv);
	  Ed->ReplaceSel(buffer);

      Ed=(CEdit*)DglView->GetDlgItem(IDC_EDITzpos);
      Ed->SetSel(0,-1);
	  wsprintf(buffer, L"%.6g", zpos);
	  Ed->ReplaceSel(buffer);

      Ed=(CEdit*)DglView->GetDlgItem(IDC_EDITzv);
      Ed->SetSel(0,-1);
	  wsprintf(buffer, L"%.6g", zv);
	  Ed->ReplaceSel(buffer);

      Ed=(CEdit*)DglView->GetDlgItem(IDC_EDITyrot);
      Ed->SetSel(0,-1);
	  wsprintf(buffer, L"%.6g", yrot);
	  Ed->ReplaceSel(buffer);

      Ed=(CEdit*)DglView->GetDlgItem(IDC_EDITxrot);
      Ed->SetSel(0,-1);
	  wsprintf(buffer, L"%.6g", xrot);
	  Ed->ReplaceSel(buffer);

			Sl=(CSliderCtrl*)DglView->GetDlgItem(IDC_EDITzpos);
			Sl->SetPos((int)zpos);
			Sl=(CSliderCtrl*)DglView->GetDlgItem(IDC_EDITxrot);
			Sl->SetPos((int)xrot);
			Sl=(CSliderCtrl*)DglView->GetDlgItem(IDC_EDITyrot);
			Sl->SetPos((int)yrot);
}
//--------------------------------------------------------------------
void CMfc_glView::OnAffichageGlview() 
{
	// TODO: Add your command handler code here
  menuAffichageGlview=!menuAffichageGlview;
  if (menuAffichageGlview)  {
                            DglView->ShowWindow( SW_SHOW);
                            SetFocus();
                            }
      else  DglView->ShowWindow( SW_HIDE);
  if (menuAffichageGlview) MiseAjourDlgView();
}
//--------------------------------------------------------------------
void CMfc_glView::OnUpdateAffichageGlview(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	menuAffichageGlview=(DglView->IsWindowVisible()!=0);
  pCmdUI->SetCheck(menuAffichageGlview);
}

void CMfc_glView::OnRunResetview() 
{
	// TODO: Add your command handler code here
	xv=0;	zv=0; zpos=+2;	//	Position de la vue
	yrot=-90; xrot=30;
	CameraMoveStep=0.4f;
	MiseAjourDlgView();
}
//---------------------------------------------------------------------------
void CMfc_glView::OnHelp() 
{
CString SS, full_path;
TCHAR application_path[MAX_PATH];
//http://www.codeguru.com/forum/showthread.php?t=355370&highlight=application+directory
	GetModuleFileName(NULL, application_path, sizeof(application_path) - 1);
  full_path=CString(application_path);
  full_path = full_path.Mid(0, full_path.ReverseFind('\\'));
  SS=SS+full_path + L"\\index.html";
	ShellExecute( NULL, NULL, SS,0,0,SW_SHOWNORMAL);

}
//---------------------------------------------------------------------------
void CMfc_glView::OnSelRobot() 
{
NewRobSel=RobSel;
CDlgIRobSel * dlg=new CDlgIRobSel();
	// TODO: Add extra validation here
	if (dlg->DoModal()!=-1)
				{
				if (NewRobSel<0 || NewRobSel>NRobots)
						{
						AfxMessageBox( L"Valeur entre en dehors des limites",MB_ICONEXCLAMATION);
						return;
						}
				ListeRobots[RobSel]->Selected=false;		//! n'est plus selectionn, la selection change
				RobSel=NewRobSel;
				ListeRobots[RobSel]->Selected=true;
				InvalidateRect(NULL);										// mets  jour l'affichage
			  pMainframe->m_ComboListe.SetCurSel(RobSel);
				UpdateStatusBarRobSel();
				}
}
//---------------------------------------------------------------------------
void CMfc_glView::OnLButtonDown(UINT nFlags, CPoint point)
{
	MouseMovesScreen=true;
	pMainframe->m_wndStatusBar.SetPaneText(pMainframe->m_wndStatusBar.CommandToIndex(ID_INDICATOR_Text), L"Mouse moves screen");
	pMainframe->m_wndStatusBar.Invalidate();
	OldMouseX=point.x;
	OldMouseY=point.y;
	CView::OnLButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void CMfc_glView::OnLButtonUp(UINT nFlags, CPoint point)
{
	MouseMovesScreen=false;
	pMainframe->m_wndStatusBar.SetPaneText(pMainframe->m_wndStatusBar.CommandToIndex(ID_INDICATOR_Text), L"");
	pMainframe->m_wndStatusBar.Invalidate();
	CView::OnLButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
void CMfc_glView::OnMouseMove(UINT nFlags, CPoint point)
{
double CameraMoveStepX, CameraMoveStepY;
	if (MouseMovesScreen)
		{
		CameraMoveStepX=(point.x-OldMouseX)/300.;
		CameraMoveStepY=(point.y-OldMouseY)/300.;
		xv-=CameraMoveStepX*cos(yrot*M_PI/180);
		zv-=CameraMoveStepX*sin(yrot*M_PI/180);
		xv+=CameraMoveStepY*sin(yrot*M_PI/180);
		zv-=CameraMoveStepY*cos(yrot*M_PI/180);
		OldMouseX=point.x;
		OldMouseY=point.y;
		MiseAjourDlgView();
		if (! m_animate)  InvalidateRect(NULL); 
		}
	if (MouseRotatesScreen)
		{
		yrot+=point.x-OldMouseX;
		if (yrot<-180)   yrot+= 360.0f;
		if (yrot>180)   yrot-= 360.0f;
		xrot+=point.y-OldMouseY;
		if (xrot>180)   xrot-= 360.0f;
		if (xrot<-180.0)   xrot+= 360.0f;
		OldMouseX=point.x;
		OldMouseY=point.y;
		MiseAjourDlgView();
		if (! m_animate)  InvalidateRect(NULL); 
		}
	CView::OnMouseMove(nFlags, point);
}
//---------------------------------------------------------------------------
void CMfc_glView::OnRButtonDown(UINT nFlags, CPoint point)
{
	MouseRotatesScreen=true;
	pMainframe->m_wndStatusBar.SetPaneText(pMainframe->m_wndStatusBar.CommandToIndex(ID_INDICATOR_Text), L"Mouse rotates screen");
	pMainframe->m_wndStatusBar.Invalidate();

	OldMouseX=point.x;
	OldMouseY=point.y;
	CView::OnRButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void CMfc_glView::OnRButtonUp(UINT nFlags, CPoint point)
{
	MouseRotatesScreen=false;
	pMainframe->m_wndStatusBar.SetPaneText(pMainframe->m_wndStatusBar.CommandToIndex(ID_INDICATOR_Text), L"");
	pMainframe->m_wndStatusBar.Invalidate();
	CView::OnRButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
BOOL CMfc_glView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
  zpos+=CameraMoveStep*zDelta*0.01;
  if (zpos<0.01)   zpos=0.01;
	MiseAjourDlgView();
	if (! m_animate)  InvalidateRect(NULL); 
	return CView::OnMouseWheel(nFlags, zDelta, pt);
}
//---------------------------------------------------------------------------
